/********************************************
 * UTIA AV CR, v.v.i
 * Signal Processing Department
 * Pod Vodarenskou vezi 4
 * 182 08 Prague
 * Czech Republic
 * web: http://zs.utia.cas.cz
 *
 * Filename: main.c
 * Date: 02.01.2016
 * Authors:
 * Lukas Kohout <kohoutl@utia.cas.cz>
 * Zdenek Pohl <xpohl@utia.cas.cz>
 * Jiri Kadlec <kadlec@utia.cas.cz>
 * Description:
 *
 * Changelog:
 * Date: 02.01.2016 two parallel HW paths
 *
 *
 ********************************************/

#ifndef _IMAGE_CORES_H_
#define _IMAGE_CORES_H_
#ifdef __cplusplus
extern "C" {
#endif

#pragma SDS data mem_attribute(yuv_data_in:PHYSICAL_CONTIGUOUS|NON_CACHEABLE)
#pragma SDS data access_pattern(yuv_data_in:SEQUENTIAL, yuv_data_out:SEQUENTIAL)
void pad1(unsigned short yuv_data_in[NUMROWS*NUMPADCOLS], unsigned short  yuv_data_out[NUMROWS*NUMCOLS]);

#pragma SDS data mem_attribute(yuv_data_in:PHYSICAL_CONTIGUOUS|NON_CACHEABLE)
#pragma SDS data access_pattern(yuv_data_in:SEQUENTIAL, yuv_data_out:SEQUENTIAL)
void pad2(unsigned short yuv_data_in[NUMROWS*NUMPADCOLS], unsigned short  yuv_data_out[NUMROWS*NUMCOLS]);

#pragma SDS data mem_attribute(yuv_data_in:PHYSICAL_CONTIGUOUS|NON_CACHEABLE)
#pragma SDS data access_pattern(yuv_data_in:SEQUENTIAL, yuv_data_out:SEQUENTIAL)
void pad3(unsigned short yuv_data_in[NUMROWS*NUMPADCOLS], unsigned short  yuv_data_out[NUMROWS*NUMCOLS]);

#pragma SDS data access_pattern(inter_pix:SEQUENTIAL, output_edge:SEQUENTIAL)
void sobel_filter1(unsigned short inter_pix[NUMROWS*NUMCOLS],unsigned char output_edge[NUMROWS*NUMCOLS]);

#pragma SDS data access_pattern(inter_pix:SEQUENTIAL, output_edge:SEQUENTIAL)
void sobel_filter2(unsigned short inter_pix[NUMROWS*NUMCOLS],unsigned char output_edge[NUMROWS*NUMCOLS]);

#pragma SDS data access_pattern(inter_pix:SEQUENTIAL, output_edge:SEQUENTIAL)
void sobel_filter3(unsigned short inter_pix[NUMROWS*NUMCOLS],unsigned char output_edge[NUMROWS*NUMCOLS]);

#pragma SDS data access_pattern(inter_pix:SEQUENTIAL, output_edge:SEQUENTIAL, original_pix:SEQUENTIAL)
void sobel_filter_pass1(unsigned short inter_pix[NUMROWS*NUMCOLS],unsigned char output_edge[NUMROWS*NUMCOLS], unsigned short original_pix[NUMROWS*NUMCOLS]);

#pragma SDS data access_pattern(inter_pix:SEQUENTIAL, output_edge:SEQUENTIAL, original_pix:SEQUENTIAL)
void sobel_filter_pass2(unsigned short inter_pix[NUMROWS*NUMCOLS],unsigned char output_edge[NUMROWS*NUMCOLS], unsigned short original_pix[NUMROWS*NUMCOLS]);

#pragma SDS data access_pattern(inter_pix:SEQUENTIAL, output_edge:SEQUENTIAL, original_pix:SEQUENTIAL)
void sobel_filter_pass3(unsigned short inter_pix[NUMROWS*NUMCOLS],unsigned char output_edge[NUMROWS*NUMCOLS], unsigned short original_pix[NUMROWS*NUMCOLS]);

#pragma SDS data access_pattern(motion_image:SEQUENTIAL, original:SEQUENTIAL, output_image:SEQUENTIAL)
void combo_image1(char pass_through_option, unsigned char motion_image[NUMROWS*NUMCOLS],unsigned short original[NUMROWS*NUMCOLS],unsigned short output_image[NUMROWS*NUMCOLS]);

#pragma SDS data access_pattern(motion_image:SEQUENTIAL, original:SEQUENTIAL, output_image:SEQUENTIAL)
void combo_image2(char pass_through_option, unsigned char motion_image[NUMROWS*NUMCOLS],unsigned short original[NUMROWS*NUMCOLS],unsigned short output_image[NUMROWS*NUMCOLS]);

#pragma SDS data access_pattern(motion_image:SEQUENTIAL, original:SEQUENTIAL, output_image:SEQUENTIAL)
void combo_image3(char pass_through_option, unsigned char motion_image[NUMROWS*NUMCOLS],unsigned short original[NUMROWS*NUMCOLS],unsigned short output_image[NUMROWS*NUMCOLS]);

#pragma SDS data access_pattern(current_pix:SEQUENTIAL)
#pragma SDS data access_pattern(previous_pix:SEQUENTIAL)
#pragma SDS data access_pattern(original:SEQUENTIAL)
#pragma SDS data access_pattern(original_output:SEQUENTIAL)
#pragma SDS data access_pattern(motion_image:SEQUENTIAL)
void diff_image1(unsigned char current_pix[NUMROWS*NUMCOLS],unsigned char previous_pix[NUMROWS*NUMCOLS], unsigned short original[NUMROWS*NUMCOLS], unsigned short original_output[NUMROWS*NUMCOLS], unsigned char motion_image[NUMROWS*NUMCOLS]);

#pragma SDS data access_pattern(current_pix:SEQUENTIAL)
#pragma SDS data access_pattern(previous_pix:SEQUENTIAL)
#pragma SDS data access_pattern(original:SEQUENTIAL)
#pragma SDS data access_pattern(original_output:SEQUENTIAL)
#pragma SDS data access_pattern(motion_image:SEQUENTIAL)
void diff_image2(unsigned char current_pix[NUMROWS*NUMCOLS],unsigned char previous_pix[NUMROWS*NUMCOLS], unsigned short original[NUMROWS*NUMCOLS], unsigned short original_output[NUMROWS*NUMCOLS], unsigned char motion_image[NUMROWS*NUMCOLS]);

#pragma SDS data access_pattern(current_pix:SEQUENTIAL)
#pragma SDS data access_pattern(previous_pix:SEQUENTIAL)
#pragma SDS data access_pattern(original:SEQUENTIAL)
#pragma SDS data access_pattern(original_output:SEQUENTIAL)
#pragma SDS data access_pattern(motion_image:SEQUENTIAL)
void diff_image3(unsigned char current_pix[NUMROWS*NUMCOLS],unsigned char previous_pix[NUMROWS*NUMCOLS], unsigned short original[NUMROWS*NUMCOLS], unsigned short original_output[NUMROWS*NUMCOLS], unsigned char motion_image[NUMROWS*NUMCOLS]);

#pragma SDS data access_pattern(input_edge:SEQUENTIAL)
#pragma SDS data access_pattern(input_pix:SEQUENTIAL)
#pragma SDS data access_pattern(median_pix:SEQUENTIAL)
#pragma SDS data access_pattern(original_pix:SEQUENTIAL)
void median_char_filter_pass1(char threshold, unsigned char input_edge[NUMROWS*NUMCOLS], unsigned short input_pix[NUMROWS*NUMCOLS],unsigned char median_pix[NUMROWS*NUMCOLS], unsigned short original_pix[NUMROWS*NUMCOLS]);

#pragma SDS data access_pattern(input_edge:SEQUENTIAL)
#pragma SDS data access_pattern(input_pix:SEQUENTIAL)
#pragma SDS data access_pattern(median_pix:SEQUENTIAL)
#pragma SDS data access_pattern(original_pix:SEQUENTIAL)
void median_char_filter_pass2(char threshold, unsigned char input_edge[NUMROWS*NUMCOLS], unsigned short input_pix[NUMROWS*NUMCOLS],unsigned char median_pix[NUMROWS*NUMCOLS], unsigned short original_pix[NUMROWS*NUMCOLS]);

#pragma SDS data access_pattern(input_edge:SEQUENTIAL)
#pragma SDS data access_pattern(input_pix:SEQUENTIAL)
#pragma SDS data access_pattern(median_pix:SEQUENTIAL)
#pragma SDS data access_pattern(original_pix:SEQUENTIAL)
void median_char_filter_pass3(char threshold, unsigned char input_edge[NUMROWS*NUMCOLS], unsigned short input_pix[NUMROWS*NUMCOLS],unsigned char median_pix[NUMROWS*NUMCOLS], unsigned short original_pix[NUMROWS*NUMCOLS]);

#pragma SDS data mem_attribute(out:PHYSICAL_CONTIGUOUS|NON_CACHEABLE)
#pragma SDS data access_pattern(in:SEQUENTIAL)
#pragma SDS data access_pattern(out:SEQUENTIAL)
void ext1(unsigned short in[NUMROWS*NUMCOLS], unsigned short out[NUMROWS*NUMPADCOLS]);

#pragma SDS data mem_attribute(out:PHYSICAL_CONTIGUOUS|NON_CACHEABLE)
#pragma SDS data access_pattern(in:SEQUENTIAL)
#pragma SDS data access_pattern(out:SEQUENTIAL)
void ext2(unsigned short in[NUMROWS*NUMCOLS], unsigned short out[NUMROWS*NUMPADCOLS]);

#pragma SDS data mem_attribute(out:PHYSICAL_CONTIGUOUS|NON_CACHEABLE)
#pragma SDS data access_pattern(in:SEQUENTIAL)
#pragma SDS data access_pattern(out:SEQUENTIAL)
void ext3(unsigned short in[NUMROWS*NUMCOLS], unsigned short out[NUMROWS*NUMPADCOLS]);

#pragma SDS data mem_attribute(out:PHYSICAL_CONTIGUOUS|NON_CACHEABLE)
#pragma SDS data access_pattern(in:SEQUENTIAL)
#pragma SDS data access_pattern(out:SEQUENTIAL)
void ext_char1(unsigned char in[NUMROWS*NUMCOLS], unsigned short out[NUMROWS*NUMPADCOLS]);

#pragma SDS data mem_attribute(out:PHYSICAL_CONTIGUOUS|NON_CACHEABLE)
#pragma SDS data access_pattern(in:SEQUENTIAL)
#pragma SDS data access_pattern(out:SEQUENTIAL)
void ext_char2(unsigned char in[NUMROWS*NUMCOLS], unsigned short out[NUMROWS*NUMPADCOLS]);

#pragma SDS data mem_attribute(out:PHYSICAL_CONTIGUOUS|NON_CACHEABLE)
#pragma SDS data access_pattern(in:SEQUENTIAL)
#pragma SDS data access_pattern(out:SEQUENTIAL)
void ext_char3(unsigned char in[NUMROWS*NUMCOLS], unsigned short out[NUMROWS*NUMPADCOLS]);

#ifdef __cplusplus
};
#endif
#endif
