# ****************************************************************************
# TE0715-02-30-1C - EMC2-DP-02 FMC - Imageon IIC
# ****************************************************************************
set_property PACKAGE_PIN G8 [get_ports imageon_iic_scl_io]
set_property PACKAGE_PIN G7 [get_ports imageon_iic_sda_io]

set_property IOSTANDARD LVCMOS18 [get_ports imageon_iic_*]
set_property SLEW SLOW [get_ports imageon_iic_*]
set_property DRIVE 8 [get_ports imageon_iic_*]

set_property PACKAGE_PIN AA14 [get_ports {imageon_reset[0]}]
#set_property IOSTANDARD LVCMOS25 [get_ports {imageon_reset[0]}]
set_property IOSTANDARD LVCMOS18 [get_ports {imageon_reset[0]}]
set_property SLEW SLOW [get_ports {imageon_reset[0]}]
set_property DRIVE 8 [get_ports {imageon_reset[0]}]

# ****************************************************************************
# TE0715-02-30-1C - EMC2-DP-02 FMC - Imageon HDMII (ADV7611)
# ****************************************************************************
set_property PACKAGE_PIN G6  [get_ports {hdmii_data[0]}]
set_property PACKAGE_PIN F6  [get_ports {hdmii_data[1]}]
set_property PACKAGE_PIN A7  [get_ports {hdmii_data[2]}]
set_property PACKAGE_PIN H4  [get_ports {hdmii_data[3]}]
set_property PACKAGE_PIN B8  [get_ports {hdmii_data[4]}]
set_property PACKAGE_PIN A6  [get_ports {hdmii_data[5]}]
set_property PACKAGE_PIN H3  [get_ports {hdmii_data[6]}]
set_property PACKAGE_PIN C8  [get_ports {hdmii_data[7]}]
set_property PACKAGE_PIN H6  [get_ports {hdmii_data[8]}]
set_property PACKAGE_PIN H5  [get_ports {hdmii_data[9]}]
set_property PACKAGE_PIN G4  [get_ports {hdmii_data[10]}]
set_property PACKAGE_PIN F4  [get_ports {hdmii_data[11]}]
set_property PACKAGE_PIN A5  [get_ports {hdmii_data[12]}]
set_property PACKAGE_PIN A4  [get_ports {hdmii_data[13]}]
set_property PACKAGE_PIN G3  [get_ports {hdmii_data[14]}]
set_property PACKAGE_PIN G2  [get_ports {hdmii_data[15]}]

set_property PACKAGE_PIN F5   [get_ports hdmii_spdif]

set_property PACKAGE_PIN AA16  [get_ports hdmii_clk]

set_property IOSTANDARD LVCMOS18 [get_ports hdmii_data*]
set_property IOSTANDARD LVCMOS18 [get_ports hdmii_spdif]
#set_property IOSTANDARD LVCMOS25 [get_ports hdmii_clk]
set_property IOSTANDARD LVCMOS18 [get_ports hdmii_clk]

create_clock -period 6.666 -name hdmii_clk -waveform {0.000 3.333} -add [get_ports hdmii_clk]

# ****************************************************************************
# TE0715-02-30-1C - EMC2-DP-02 FMC - Imageon HDMIO (ADV7511)
# ****************************************************************************
set_property PACKAGE_PIN G1 [get_ports {hdmio_data[0]}]
set_property PACKAGE_PIN H1 [get_ports {hdmio_data[1]}]
set_property PACKAGE_PIN D7 [get_ports {hdmio_data[2]}]
set_property PACKAGE_PIN D2 [get_ports {hdmio_data[3]}]
set_property PACKAGE_PIN D6 [get_ports {hdmio_data[4]}]
set_property PACKAGE_PIN F2 [get_ports {hdmio_data[5]}]
set_property PACKAGE_PIN C5 [get_ports {hdmio_data[6]}]
set_property PACKAGE_PIN E2 [get_ports {hdmio_data[7]}]
set_property PACKAGE_PIN F1 [get_ports {hdmio_data[8]}]
set_property PACKAGE_PIN C3 [get_ports {hdmio_data[9]}]
set_property PACKAGE_PIN C6 [get_ports {hdmio_data[10]}]
set_property PACKAGE_PIN C4 [get_ports {hdmio_data[11]}]
set_property PACKAGE_PIN D3 [get_ports {hdmio_data[12]}]
set_property PACKAGE_PIN B6 [get_ports {hdmio_data[13]}]
set_property PACKAGE_PIN D5 [get_ports {hdmio_data[14]}]
set_property PACKAGE_PIN B7 [get_ports {hdmio_data[15]}]

set_property PACKAGE_PIN E5 [get_ports hdmio_spdif]

set_property PACKAGE_PIN AA17 [get_ports hdmio_clk]

set_property IOSTANDARD LVCMOS18 [get_ports hdmio_data*]
set_property IOSTANDARD LVCMOS18 [get_ports hdmio_spdif]
#set_property IOSTANDARD LVCMOS25 [get_ports hdmio_clk]
set_property IOSTANDARD LVCMOS18 [get_ports hdmio_clk]

create_clock -period 6.666 -name hdmio_clk -waveform {0.000 3.333} -add [get_ports hdmio_clk]
