/*****************************************************************************
 *
 *     Author: Xilinx, Inc.
 *
 *     This text contains proprietary, confidential information of
 *     Xilinx, Inc. , is distributed by under license from Xilinx,
 *     Inc., and may be used, copied and/or disclosed only pursuant to
 *     the terms of a valid license agreement with Xilinx, Inc.
 *
 *     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
 *     AS A COURTESY TO YOU, SOLELY FOR USE IN DEVELOPING PROGRAMS AND
 *     SOLUTIONS FOR XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE,
 *     OR INFORMATION AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE,
 *     APPLICATION OR STANDARD, XILINX IS MAKING NO REPRESENTATION
 *     THAT THIS IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
 *     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
 *     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
 *     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
 *     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
 *     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
 *     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *     FOR A PARTICULAR PURPOSE.
 *
 *     Xilinx products are not intended for use in life support appliances,
 *     devices, or systems. Use in such applications is expressly prohibited.
 *
 *     (c) Copyright 2011 Xilinx Inc.
 *     All rights reserved.
 *
 *****************************************************************************/


/********************************************
 * UTIA AV CR, v.v.i
 * Signal Processing Department
 * Pod Vodarenskou vezi 4
 * 182 08 Prague
 * Czech Republic
 * web: http://zs.utia.cas.cz
 *
 * Filename: main.c
 * Date: 02.01.2016
 * Authors:
 * Lukas Kohout <kohoutl@utia.cas.cz>
 * Zdenek Pohl <xpohl@utia.cas.cz>
 * Jiri Kadlec <kadlec@utia.cas.cz>
 * Description:
 *
 * Changelog:
 * Date: 02.01.2016 two parallel HW paths
 *
 *
 ********************************************/

/*
 * Sobel demo code
 */

#include <stdio.h>
#include "frame_size.h"
#include "image_cores.h"

void combo_image1(char pass_through_option, unsigned char motion_image[NUMROWS*NUMCOLS],unsigned short original[NUMROWS*NUMCOLS],unsigned short output_image[NUMROWS*NUMCOLS])
{
  int i;
  int j;
  unsigned short original_pix;
  unsigned char diff_pix;
  unsigned short combo_pix;
  const unsigned char y = 76;
  const unsigned char u = 84;
  const unsigned char v = 255;

  for(i=0; i < NUMROWS; i++){
    for(j=0; j < NUMCOLS; j++){
#pragma AP PIPELINE II = 1
      original_pix = original[i*NUMCOLS + j];
      diff_pix = motion_image[i*NUMCOLS + j];
      if(diff_pix == 254){
	if(j%2){
	  combo_pix = ((unsigned short)v << 8) | y;
	}
	else{
	  combo_pix = ((unsigned short)u << 8) | y;
	}
      }
      else{
	combo_pix = original_pix;
      }
      if (pass_through_option == 1) {
         output_image[i*NUMCOLS + j] = original_pix;
      }
      else {
         output_image[i*NUMCOLS + j] = combo_pix;
      }
    }
  }
}

void combo_image2(char pass_through_option, unsigned char motion_image[NUMROWS*NUMCOLS],unsigned short original[NUMROWS*NUMCOLS],unsigned short output_image[NUMROWS*NUMCOLS])
{
  int i;
  int j;
  unsigned short original_pix;
  unsigned char diff_pix;
  unsigned short combo_pix;
  const unsigned char y = 76;
  const unsigned char u = 84;
  const unsigned char v = 255;

  for(i=0; i < NUMROWS; i++){
    for(j=0; j < NUMCOLS; j++){
#pragma AP PIPELINE II = 1
      original_pix = original[i*NUMCOLS + j];
      diff_pix = motion_image[i*NUMCOLS + j];
      if(diff_pix == 254){
	if(j%2){
	  combo_pix = ((unsigned short)v << 8) | y;
	}
	else{
	  combo_pix = ((unsigned short)u << 8) | y;
	}
      }
      else{
	combo_pix = original_pix;
      }
      if (pass_through_option == 1) {
         output_image[i*NUMCOLS + j] = original_pix;
      }
      else {
         output_image[i*NUMCOLS + j] = combo_pix;
      }
    }
  }
}




