/********************************************
 * UTIA AV CR, v.v.i
 * Signal Processing Department
 * Pod Vodarenskou vezi 4
 * 182 08 Prague
 * Czech Republic
 * web: http://zs.utia.cas.cz
 *
 * Filename: main.c
 * Date: 02.01.2016
 * Authors:
 * Lukas Kohout <kohoutl@utia.cas.cz>
 * Zdenek Pohl <xpohl@utia.cas.cz>
 * Jiri Kadlec <kadlec@utia.cas.cz>
 * Description:
 *
 * Changelog:
 * Date: 02.01.2016 two parallel HW paths
 *
 *
 ********************************************/


/*
 * convert ycbcr to rgb for logicvc input (ff_b_g_r) and pad each line to 2048 ints
 */

#include <stdio.h>
#include "frame_size.h"
#include "image_cores.h"

//Main function for ycbcr2rgb with padding to 2048 pixel line
void ext1(unsigned short in[NUMROWS*NUMCOLS], unsigned short out[NUMROWS*NUMPADCOLS])
{
  int row;
  int col;
  //#pragma AP DATAFLOW
  for(row = 0; row < NUMROWS; row++){
    for(col = 0; col < NUMCOLS; col++){
#pragma AP PIPELINE II = 1
      unsigned short input_data;
      input_data = in[row*NUMCOLS+col];
      out[row*NUMPADCOLS+col] = input_data;
    }
    for (col = NUMCOLS; col < NUMPADCOLS; col++) {
#pragma AP PIPELINE II = 1
      out[row*NUMPADCOLS+col] = 0;
    }
  }
}

//Main function for ycbcr2rgb with padding to 2048 pixel line
void ext_char1(unsigned char in[NUMROWS*NUMCOLS], unsigned short out[NUMROWS*NUMPADCOLS])
{
  int row;
  int col;
  //#pragma AP DATAFLOW
  for(row = 0; row < NUMROWS; row++){
    for(col = 0; col < NUMCOLS; col++){
#pragma AP PIPELINE II = 1
      unsigned short input_data;
      input_data = in[row*NUMCOLS+col];
      out[row*NUMPADCOLS+col] = (0x80 << 8) | input_data;
    }
    for (col = NUMCOLS; col < NUMPADCOLS; col++) {
#pragma AP PIPELINE II = 1
      out[row*NUMPADCOLS+col] = 0;
    }
  }
}

//Main function for ycbcr2rgb with padding to 2048 pixel line
void ext2(unsigned short in[NUMROWS*NUMCOLS], unsigned short out[NUMROWS*NUMPADCOLS])
{
  int row;
  int col;
  //#pragma AP DATAFLOW
  for(row = 0; row < NUMROWS; row++){
    for(col = 0; col < NUMCOLS; col++){
#pragma AP PIPELINE II = 1
      unsigned short input_data;
      input_data = in[row*NUMCOLS+col];
      out[row*NUMPADCOLS+col] = input_data;
    }
    for (col = NUMCOLS; col < NUMPADCOLS; col++) {
#pragma AP PIPELINE II = 1
      out[row*NUMPADCOLS+col] = 0;
    }
  }
}

//Main function for ycbcr2rgb with padding to 2048 pixel line
void ext_char2(unsigned char in[NUMROWS*NUMCOLS], unsigned short out[NUMROWS*NUMPADCOLS])
{
  int row;
  int col;
  //#pragma AP DATAFLOW
  for(row = 0; row < NUMROWS; row++){
    for(col = 0; col < NUMCOLS; col++){
#pragma AP PIPELINE II = 1
      unsigned short input_data;
      input_data = in[row*NUMCOLS+col];
      out[row*NUMPADCOLS+col] = (0x80 << 8) | input_data;
    }
    for (col = NUMCOLS; col < NUMPADCOLS; col++) {
#pragma AP PIPELINE II = 1
      out[row*NUMPADCOLS+col] = 0;
    }
  }
}

//Main function for ycbcr2rgb with padding to 2048 pixel line
void ext3(unsigned short in[NUMROWS*NUMCOLS], unsigned short out[NUMROWS*NUMPADCOLS])
{
  int row;
  int col;
  //#pragma AP DATAFLOW
  for(row = 0; row < NUMROWS; row++){
    for(col = 0; col < NUMCOLS; col++){
#pragma AP PIPELINE II = 1
      unsigned short input_data;
      input_data = in[row*NUMCOLS+col];
      out[row*NUMPADCOLS+col] = input_data;
    }
    for (col = NUMCOLS; col < NUMPADCOLS; col++) {
#pragma AP PIPELINE II = 1
      out[row*NUMPADCOLS+col] = 0;
    }
  }
}

//Main function for ycbcr2rgb with padding to 2048 pixel line
void ext_char3(unsigned char in[NUMROWS*NUMCOLS], unsigned short out[NUMROWS*NUMPADCOLS])
{
  int row;
  int col;
  //#pragma AP DATAFLOW
  for(row = 0; row < NUMROWS; row++){
    for(col = 0; col < NUMCOLS; col++){
#pragma AP PIPELINE II = 1
      unsigned short input_data;
      input_data = in[row*NUMCOLS+col];
      out[row*NUMPADCOLS+col] = (0x80 << 8) | input_data;
    }
    for (col = NUMCOLS; col < NUMPADCOLS; col++) {
#pragma AP PIPELINE II = 1
      out[row*NUMPADCOLS+col] = 0;
    }
  }
}
