/*****************************************************************************
 *
 *     Author: Xilinx, Inc.
 *
 *     This text contains proprietary, confidential information of
 *     Xilinx, Inc. , is distributed by under license from Xilinx,
 *     Inc., and may be used, copied and/or disclosed only pursuant to
 *     the terms of a valid license agreement with Xilinx, Inc.
 *
 *     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
 *     AS A COURTESY TO YOU, SOLELY FOR USE IN DEVELOPING PROGRAMS AND
 *     SOLUTIONS FOR XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE,
 *     OR INFORMATION AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE,
 *     APPLICATION OR STANDARD, XILINX IS MAKING NO REPRESENTATION
 *     THAT THIS IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
 *     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
 *     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
 *     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
 *     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
 *     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
 *     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *     FOR A PARTICULAR PURPOSE.
 *
 *     Xilinx products are not intended for use in life support appliances,
 *     devices, or systems. Use in such applications is expressly prohibited.
 *
 *     (c) Copyright 2013 Xilinx Inc.
 *     All rights reserved.
 *
 *****************************************************************************/

/********************************************
 * UTIA AV CR, v.v.i
 * Signal Processing Department
 * Pod Vodarenskou vezi 4
 * 182 08 Prague
 * Czech Republic
 * web: http://zs.utia.cas.cz
 *
 * Filename: main.c
 * Date: 02.01.2016
 * Authors:
 * Lukas Kohout <kohoutl@utia.cas.cz>
 * Zdenek Pohl <xpohl@utia.cas.cz>
 * Jiri Kadlec <kadlec@utia.cas.cz>
 * Description:
 *
 * Changelog:
 * Date: 02.01.2016 two parallel HW paths
 *
 *
 ********************************************/


#include <stdio.h>
#include "frame_size.h"
#include "image_cores.h"

void pad1(unsigned short yuv_data_in[NUMROWS*NUMPADCOLS], unsigned short  yuv_data_out[NUMROWS*NUMCOLS])
{

  int row;
  int col;

  for(row = 0; row < NUMROWS; row++){
    for(col = 0; col < NUMCOLS; col++){
    	unsigned short pixel;
#pragma AP PIPELINE II = 1
    	pixel = yuv_data_in[row*NUMPADCOLS+col];
        yuv_data_out[row*NUMCOLS+col] = pixel;
    }
    for (col = NUMCOLS; col < NUMPADCOLS; col++) {
        volatile unsigned pixel0;
#pragma AP PIPELINE II = 1
	pixel0 = yuv_data_in[row*NUMPADCOLS+col];
    }
 }
}

void pad2(unsigned short yuv_data_in[NUMROWS*NUMPADCOLS], unsigned short  yuv_data_out[NUMROWS*NUMCOLS])
{

  int row;
  int col;

  for(row = 0; row < NUMROWS; row++){
    for(col = 0; col < NUMCOLS; col++){
    	unsigned short pixel;
#pragma AP PIPELINE II = 1
    	pixel = yuv_data_in[row*NUMPADCOLS+col];
        yuv_data_out[row*NUMCOLS+col] = pixel;
    }
    for (col = NUMCOLS; col < NUMPADCOLS; col++) {
        volatile unsigned pixel0;
#pragma AP PIPELINE II = 1
	pixel0 = yuv_data_in[row*NUMPADCOLS+col];
    }
 }
}

void pad3(unsigned short yuv_data_in[NUMROWS*NUMPADCOLS], unsigned short  yuv_data_out[NUMROWS*NUMCOLS])
{

  int row;
  int col;

  for(row = 0; row < NUMROWS; row++){
    for(col = 0; col < NUMCOLS; col++){
    	unsigned short pixel;
#pragma AP PIPELINE II = 1
    	pixel = yuv_data_in[row*NUMPADCOLS+col];
        yuv_data_out[row*NUMCOLS+col] = pixel;
    }
    for (col = NUMCOLS; col < NUMPADCOLS; col++) {
        volatile unsigned pixel0;
#pragma AP PIPELINE II = 1
	pixel0 = yuv_data_in[row*NUMPADCOLS+col];
    }
 }
}

